// --- [ bmp085_a.h ] ------------------------------------------------------------
//
//       tab = 3 - 15.05.11
//
//       Der EOC-Pin ist ohne weitere Pullups direkt mit PIND.4 verbunden

// -- hier knnen die Parameter gewhlt werden
#define EOC_ENABLE					TRUE		// Wartezeit ber EOC regeln [TRUE/FALSE]
#define BMP085_OSS 					3			// Oversampling Setting [0 .. 3]
#define READ_BIT						19			// 16 oder 19 Bit lesen [16 oder 19]
#define SOFTWARE_SAMPLES			4			// Anzahl der Software Pressure Samples (2^n)
#define FLOATING_AVERAGE			TRUE		// Mittelwert ber mehrere Messungen bilden [TRUE/FALSE]
#define AVERAGE_SAMPLES				4			// Anzahl der einzubeziehenden Messungen (2^n, aber > 1)

// --- Pins fr EOC
#define EOC_PORT						PIND
#define EOC_PIN						PD4
#define BMP085_busy					(!(EOC_PORT & (1<<EOC_PIN)))

// --- Adressen
#define BMP085_TWI_ADR				0xEE
#define BMP085_CONTROL_REG			0xF4
#define BMP085_DATA_REG				0xF6
#define BMP085_CHIP_ID_REG			0xD0
#define BMP085_VERSION_REG			0xD1

#define BMP085_READ_TEMPERATURE	0x2E
#define BMP085_READ_PRESSURE		0x34

#if BMP085_OSS == 0
	#undef  READ_BIT
	#define READ_BIT					16			// Bei OSS == 0 sind 19 Bit sinnfrei
#endif

#if AVERAGE_SAMPLES < 2							
	#undef FLOATING_AVERAGE
	#define FLOATING_AVERAGE 		FALSE
#endif

uint16_t BMP085_Read_Data(uint8_t adr);
void BMP085_Read_Calibration(void);
void BMP085_Convert(long * temperature, long * pressure);

// --- [ eof ] -----------------------------------------------------------------