// --- [ rs232.c ] ------------------------------------------------------------
//

#include <avr/io.h>
#include <avr/pgmspace.h>  
#include "rs232.h"
#include "global.h"

/*
#define UBRRL UBRR0L
#define UBRRH UBRR0H
#define UDR   UDR0
#define UCSRA UCSR0A
#define UCSRB UCSR0B
#define UCSRC UCSR0C

#define TXEN  TXEN0
#define RXEN  RXEN0
#define RXCIE RXCIE0
#define UCSZ0 UCSZ00
#define UCSZ1 UCSZ01
#define UCSRC UCSR0C
#define UMSEL UMSEL01
#define UDRE  UDRE0
*/

// --- lokale Variablen -------------------------------------------------------

/*
// ----------------------------------------------------------------------------
// initialisiert die RS232-Schnittstelle (ATMEGA8)
void rs232_init(void)
{
	UBRRL = TEILER;	
	UBRRH = 0;
	UCSRB |= (1<<RXCIE | 1<<TXEN | 1<<RXEN);

	//UCSRC |= (1<<URSEL | 0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
	// URSEL - Achtung bei ATmega 8
	UCSRC |= (0<<UMSEL) | (1<<UCSZ1) | (1<<UCSZ0);
   
	rx_head = rx_tail = 0;
}
*/

// ----------------------------------------------------------------------------
// initialisiert die RS232-Schnittstelle (ATMEGAxx8
void rs232_init(void)
{

UBRR0L = TEILER;									// siehe rs232_int.h
UBRR0H = 0;
UCSR0C = (0<<UMSEL01) | (1<<UCSZ01) | (1<<UCSZ00);

DISABLE_RX();
}


// --- Standard-Routinen ------------------------------------------------------
// ----------------------------------------------------------------------------
// ein einzelnes Zeichen auf COM ausgeben
void put_c(uint8_t Zeichen)
{
while(!(UCSR0A & (1<<UDRE0)));
UDR0 = Zeichen;
}

// ----------------------------------------------------------------------------
// einen String auf COM ausgeben
void put_s(char *s)
{
while(*s)
	{
	put_c(*s);
	s++;
	}
}

// ----------------------------------------------------------------------------
// gibt einen String aus dem Flash aus
void puts_p(const char *progmem_s)
{
register char c;
while ( (c = pgm_read_byte(progmem_s++)) )
	{
   put_c(c);
	}
}


// --- [ eof ] ----------------------------------------------------------------

